

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "AST.h"

int main(int argc, char** argv)
{
  if (argc < 1) {
    fprintf(stderr, "Veuillez indiquer un fichier à lire en argument");
    return -1;
  }
  FILE *myfile = fopen(argv[1], "r");
  if (!myfile) {
    fprintf(stderr, "code illisible!");
    return -1;
  }


  // creation d'une machine vide
  struct PMachine* pmachine = (struct  PMachine*)malloc( sizeof( struct  PMachine ) );
  pmachine->PC = 0;
  pmachine->SP = -1;
  pmachine->MP = 0;
  pmachine->HP = 1000;
  pmachine->MAX = 0;
  pmachine->CODEMAX = 0;
  pmachine->RAM = 0;
  pmachine->RAMT = 0;
  pmachine->CODE = 0;

  // initialisation avec le ficier de code
  parse(pmachine, myfile);

  // recuperation des variables de la machine
  int  PC = pmachine->PC;
  int  SP = pmachine->SP;
  int  HP = pmachine->HP;
  int  MP = pmachine->MP;
  int  MAX = pmachine->MAX;
  int  CODEMAX = pmachine->CODEMAX;
  int* RAM = pmachine->RAM;
  int* RAMT = pmachine->RAMT;
  struct CommandeA* CODE = pmachine->CODE;


  

  // fonction base pour le package 3
  int base(int p, int a) { if (p==0) {return a;} else {return base(p,RAM[a+1]);} }
  
  // impression de l'etat initial de la machine
  printf( "PC = %i  SP=%i   HP=%i   MP=%i   CODEMAX =%i\n", PC, SP, HP, MP, CODEMAX);
  int i = 0;
  printf("CODE:\n");
  while (i <= CODEMAX) { printf( " CODE[%i]:  op:%s  type:%c  p:%i  q:%i\n", i++,(CODE[i]).op,(CODE[i]).type, (CODE[i]).p,(CODE[i]).q);}
  i = 0;
  printf("RAM:\n");
  while (i <= MAX) { printf( " RAM[%i]=  %i\n", i++,RAM[i]);}

  // Debut de l'execution
  printf( "\ndebut\n PC    sortie\n" );
  while (PC <= CODEMAX) {
    // Impression de PC a chaque etape
    struct CommandeA com =  CODE[PC];
    printf( "\n%i", PC++);
    // Choix de la commande
    if (strcmp(com.op, "and") == 0) {
      if (! (RAMT[SP]=='b' && RAMT[SP-1] == 'b')) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] && RAM[SP];
    } else if (strcmp(com.op, "or") == 0) {
      if (! (RAMT[SP]=='b' && RAMT[SP-1] == 'b')) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] || RAM[SP];
    } else if (strcmp(com.op, "not") == 0) {
      if (! (RAMT[SP]=='b')) {printf("    Erreur de type");}
      RAM[SP]   = ! RAM[SP];
    } else if (strcmp(com.op, "equ") == 0) {
      if (! (RAMT[SP]==com.type && RAMT[SP-1] == com.type)) {printf("    Erreur de type");}
      RAM[SP-1] = (RAM[SP--] == RAM[SP]);
      RAMT[SP] = 'b';
    } else if (strcmp(com.op, "geq") == 0) {
      if (! (RAMT[SP]==com.type && RAMT[SP-1] == com.type)) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] >= RAM[SP];
      RAMT[SP] = 'b';
    } else if  (strcmp(com.op, "leq") == 0) {
      if (! (RAMT[SP]==com.type && RAMT[SP-1] == com.type)) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] <= RAM[SP];
      RAMT[SP] = 'b';
    } else if  (strcmp(com.op, "les") == 0) {
      if (! (RAMT[SP]==com.type && RAMT[SP-1] == com.type)) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] < RAM[SP];
      RAMT[SP] = 'b';
    } else if  (strcmp(com.op, "ges") == 0) {
      if (! (RAMT[SP]==com.type && RAMT[SP-1] == com.type)) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] > RAM[SP];
      RAMT[SP] = 'b';
    } else if  (strcmp(com.op, "neq") == 0) {
      if (! (RAMT[SP]==com.type && RAMT[SP-1] == com.type)) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] != RAM[SP];
      RAMT[SP] = 'b';
    } else if  (strcmp(com.op, "add") == 0) {
      if (! (RAMT[SP]==com.type && RAMT[SP-1] == com.type)) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] + RAM[SP];
    } else if  (strcmp(com.op, "sub") == 0) {
      if (! (RAMT[SP]==com.type && RAMT[SP-1] == com.type)) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] - RAM[SP];
    } else if  (strcmp(com.op, "mul") == 0) {
      if (! (RAMT[SP]==com.type && RAMT[SP-1] == com.type)) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] * RAM[SP];
    } else if (strcmp(com.op, "neg") == 0) {
      if (! (RAMT[SP]==com.type && RAMT[SP-1] == com.type)) {printf("    Erreur de type");}
      RAM[SP]   = - RAM[SP];
    } else if (strcmp(com.op, "ido") == 0) {
      if (! (RAMT[com.q]==com.type)) {printf("    Erreur de type");}
      if (++SP >= HP) {fprintf(stderr,"dépacement de mémoir à la commande %s en PC = %i", com.op, PC); break;}
      RAM[SP]  = RAM[com.q];
      RAMT[SP] = com.type;
    } else if (strcmp(com.op, "idc") == 0) {
      if (++SP >= HP) {fprintf(stderr,"dépacement de mémoir à la commande %s en PC = %i", com.op, PC); break;}
      RAM[SP]  = com.q;
      RAMT[SP] = com.type;
    } else if (strcmp(com.op, "sro") == 0) {
      if (! (RAMT[SP]==com.type)) {printf("    Erreur de type");}
      RAM[com.q]  = RAM[SP--];
      RAMT[com.q] = com.type;
    } else if (strcmp(com.op, "ujp") == 0) {
      PC        = com.q;
    } else if (strcmp(com.op, "fjp") == 0) {
      if (! (RAMT[SP]=='b')) {printf("    Erreur de type");}
      if (! RAM[SP--]) {
	PC      = com.q;
      }
    } else if (strcmp(com.op, "wrt") == 0) {
      switch (com.type) {
      case 'i':
	printf( "     %i", RAM[SP--]);
	break;;
      case 'f':
	printf( "     %d", RAM[SP--]);
	break;;
      case 'c':
	printf( "     %c", RAM[SP--]);
	break;;
      case 'a':
	printf( "     \nadr%i", RAM[SP--]);
	break;;
      default:
	printf( "     %c n'est pas un type admisible\n", com.type);
	SP--;
      }
    } else if  (strcmp(com.op, "ixa") == 0) {
      if (! (RAMT[SP]=='i'  &&  RAMT[SP-1]=='a')) {printf("    Erreur de type");}
      RAM[SP-1] = RAM[SP--] + com.q * RAM[SP];
    } else if  (strcmp(com.op, "dpl") == 0) {
      if (++SP >= HP) {fprintf(stderr,"dépacement de mémoir à la commande %s en PC = %i", com.op, PC); break;}
      RAM[SP]  = RAM[SP-1];
      RAMT[SP] = RAMT[SP-1];
    } else if  (strcmp(com.op, "ddp") == 0) {
      if (++SP >= HP) {fprintf(stderr,"dépacement de mémoir à la commande %s en PC = %i", com.op, PC); break;}
      RAM[SP]  = RAM[SP-2];
      RAMT[SP] = RAMT[SP-2];
    } else if  (strcmp(com.op, "ind") == 0) {
      if (! (RAMT[SP]=='a')) {printf("    Erreur de type");}
      RAM[SP] = RAM[RAM[SP]];
      RAMT[SP] = RAMT[RAM[SP]];
    } else if  (strcmp(com.op, "sto") == 0) {
      if (! (RAMT[SP]==com.type  &&  RAMT[SP-1]=='a')) {printf("    Erreur de type");}
      RAM[RAM[SP-1]] = RAM[SP--];
      RAMT[RAM[SP]] =com.type ; 
      SP--;
    } else if  (strcmp(com.op, "new") == 0) {
      if (! (RAMT[SP]=='i'  &&  RAMT[SP-1]=='a')) {printf("    Erreur de type");}
      HP = HP-RAM[SP--];
      RAM[RAM[SP--]] = HP;
      if (SP >= HP) {fprintf(stderr,"dépacement de mémoir à la commande %s en PC = %i", com.op, PC); break;}
      RAMT[RAM[SP+1]] = 'a'; 
    } else if  (strcmp(com.op, "nwt") == 0) {
      if (! (RAMT[SP]=='i'  &&  RAMT[SP-1]=='a')) {printf("    Erreur de type");}
      HP = HP-RAM[SP]-1;
      if (SP >= HP) {fprintf(stderr,"dépacement de mémoir à la commande %s en PC = %i", com.op, PC); break;}
      RAM[HP] = RAM[SP--];
      RAMT[RAM[SP+1]] = 'i'; 
      RAM[RAM[SP--]] = HP;
      RAMT[RAM[SP+1]] = 'a'; 
    } else if  (strcmp(com.op, "iod") == 0) {
      if (++SP >= HP) {fprintf(stderr,"dépacement de mémoir à la commande %s en PC = %i", com.op, PC); break;}
      RAM[SP] = RAM[base(com.p,MP) + com.q];
      RAMT[SP] = com.type;
    } else if  (strcmp(com.op, "ida") == 0) {
      if (++SP >= HP) {fprintf(stderr,"dépacement de mémoir à la commande %s en PC = %i", com.op, PC); break;}
      RAM[SP] = base(com.p,MP) + com.q;
      RAMT[SP] = 'a';
    } else if  (strcmp(com.op, "str") == 0) {
      if (! (RAMT[SP]==com.type)) {printf("    Erreur de type");}
      RAM[base(com.p,MP)] = RAM[SP--];
    } else if  (strcmp(com.op, "mst") == 0) {
      if (SP+4 >= HP) {fprintf(stderr,"dépacement de mémoir à la commande %s en PC = %i", com.op, PC); break;}
      SP++;
      RAM[++SP] = base(com.p,MP);
      RAMT[SP] = 'a';
      RAM[++SP] = MP;
      RAMT[SP] = 'a';
      SP++;
    } else if  (strcmp(com.op, "cup") == 0) {
      MP = SP - (com.p + 3);
      RAM[MP+3] = PC;
      RAMT[MP+3] = 'i';
    } else if  (strcmp(com.op, "retp") == 0) {
      SP = MP-1;
      PC = RAM[MP + 3];
      MP = RAM[MP + 2];
    } else if  (strcmp(com.op, "retf") == 0) {
      RAM[MP] = RAM[SP];
      RAMT[MP] = RAMT[SP];
      SP = MP;
      PC = RAM[MP + 3];
      MP = RAM[MP + 2];
    } else {
	printf( "%s n'est pas une opération supportée\n", com.op);
    }
  }
  
  printf( "\n\nfin \n\n" );
  // Fin de l'execution
  
  // Impression de l'etat final
  printf( "PC = %i   SP=%i   HP=%i   MP=%i   CODEMAX =%i\n", PC, SP, HP, MP, CODEMAX);
  i = 0;
  printf("RAM:\n");
  while (i <= MAX) { 
    printf( " RAM[%i]=", i);
      switch (RAMT[i]) {
      case 'i':
	printf( "  %i\n", RAM[i]);
	break;;
      case 'f':
	printf( "  %d\n", RAM[i]);
	break;;
      case 'c':
	printf( "  %c\n", RAM[i]);
	break;;
      case 'a':
	printf( "  \nadr%i\n", RAM[i]);
	break;;
      default:
	printf( " %i  (type indef) \n", RAM[i]);
      }
      i++;
  }
 
}
