
%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "AST.h"


  extern FILE* yyin;

  int pos = 0;
  int codemax = 0;
  
%}

%parse-param {struct PMachine* pmachine}

%union {
  int   num;
  char  op[4];
  char  tp;
}


%token <num>    NOMBRE
%token <tp>    TYPE
%token <op>    OP
%token EOP MAX CODEMAX RAM CODE SP HP MP PC END

%start programme


%%

programme:
  commande programme    
| END                            {}

commande:
  MAX '=' NOMBRE                 {pmachine->RAM =malloc(($3+1)*sizeof(int)); pmachine->RAMT =malloc(($3+1)*sizeof(int)); pmachine->MAX = $3;}
| CODEMAX '=' NOMBRE             {pmachine->CODE = malloc(($3+1) * sizeof(struct CommandeA)); ; pmachine->CODEMAX = $3;}
| RAM'['NOMBRE']'  '=' NOMBRE    {pmachine->RAM[$3] = $6;}
| SP  '=' NOMBRE                 {pmachine->SP = $3;}
| PC  '=' NOMBRE                 {pmachine->PC = $3;}
| HP  '=' NOMBRE                 {pmachine->HP = $3;}
| MP  '=' NOMBRE                 {pmachine->MP = $3;}
| OP args                        {if (pos > pmachine->CODEMAX) {
                                      fprintf(stderr, "cela fait plus de %i instructions\n", pmachine->CODEMAX);
                                    } else {
                                      strcpy((pmachine->CODE[pos++]).op ,$1);
                                 }  }
;

args:
  ';'                            
| '('TYPE')' args                {pmachine->CODE[pos].type = $2;}
| TYPE   args                    {pmachine->CODE[pos].type = $1;}
| NOMBRE args                    {if (pmachine->CODE[pos].arity) {
                                      pmachine->CODE[pos].p=$1; 
                                      pmachine->CODE[pos].arity=2;
                                    } else {
                                      pmachine->CODE[pos].q=$1; 
                                      pmachine->CODE[pos].arity=1; 
                                 }  }
  ;

%%

#include <stdio.h>
#include <stdlib.h>

int parse(struct PMachine* pmachine, FILE* myfile) {
	yyin = myfile;
	do { 
	  yyparse(pmachine);
	} while(!feof(yyin));
	return 0;
}

void yyerror(struct PMachine* p,const char* s) {
  fprintf(stderr, "Parse error: %s\n", s);
  exit(1);
}
